package com.fp.persistence.parmas.param;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMORIGENTRAMITE*/
@Entity(name="TarmOrigenTramite")
@Table(name="TARMORIGENTRAMITE")
public class TarmOrigenTramite extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmOrigenTramite
*/
@EmbeddedId
private TarmOrigenTramiteKey pk;
/**Contructor por defecto*/
public TarmOrigenTramite(){
}
/**Contructor de TarmOrigenTramite
@param pPk Clave Primaria del entity
*/
public TarmOrigenTramite(TarmOrigenTramiteKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmOrigenTramite
*/
public static TarmOrigenTramite find(EntityManager pEntityManager,TarmOrigenTramiteKey pKey) throws Exception{
    TarmOrigenTramite obj = pEntityManager.find(TarmOrigenTramite.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmOrigenTramite
@return El objeto que referencia a la Clave primaria de TarmOrigenTramite
*/
public TarmOrigenTramiteKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmOrigenTramite
@param pPk El objeto que referencia a la nueva Clave primaria de TarmOrigenTramite
*/
public void setPk(TarmOrigenTramiteKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmOrigenTramite))return false;
    TarmOrigenTramite that = (TarmOrigenTramite) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmOrigenTramite
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmOrigenTramite
*/
public Object createInstance(){
 TarmOrigenTramite instance=new TarmOrigenTramite();	
 instance.setPk(new TarmOrigenTramiteKey());
 return instance;
}
/**Clona la entidad TarmOrigenTramite
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmOrigenTramite p=(TarmOrigenTramite)this.clone();
  p.setPk((TarmOrigenTramiteKey)this.pk.cloneMe());
  return p;
}
}
